/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: net_buf.h,v 1.5 2009/12/24 05:42:40 abe Exp $
 */

#ifndef _NET_BUF_H_
#define _NET_BUF_H_

/*
 *  ͥåȥХåե
 *
 *    4 ƥåȤǥ饤󤹤ɬפΤץåθơ
 *    IF إå 4 ƥåȶǤʤξ硢
 *    IP إåʹߤ 4 ƥåȶĴ롣
 */

#ifndef CPU_NET_ALIGN
#error "CPU_NET_ALIGN expected."
#endif

/*
 *  ƥץ졼
 */

struct t_net_buf {
	uint16_t	len;	/* ǡĹ		*/
	uint8_t		idix;	/* mpfid Υǥå	*/
	uint8_t		flags;	/* ե饰		*/
#ifdef IF_ETHER_NIC_NET_BUF_ALIGN
	uint8_t		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
#endif
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	uint8_t		halign[4 - IF_HDR_ALIGN];
#endif
	uint8_t		buf[4];	/* Хåե		*/
	};

#ifndef T_NET_BUF_DEFINED

typedef struct t_net_buf T_NET_BUF;

#define T_NET_BUF_DEFINED

#endif	/* of #ifndef T_NET_BUF_DEFINED */
/*
 *  64 ƥå
 */

typedef struct t_net_buf_64 {
	uint16_t	len;	/* ǡĹ		*/
	uint8_t		idix;	/* mpfid Υǥå	*/
	uint8_t		flags;	/* ե饰		*/
#ifdef IF_ETHER_NIC_NET_BUF_ALIGN
	uint8_t		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
#endif
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	uint8_t		halign[4 - IF_HDR_ALIGN];
#endif
	uint8_t		buf[64]; /* Хåե	*/
	} T_NET_BUF_64;

/*
 *  128 ƥå
 */

typedef struct t_net_buf_128 {
	uint16_t	len;	/* ǡĹ		*/
	uint8_t		idix;	/* mpfid Υǥå	*/
	uint8_t		flags;	/* ե饰		*/
#ifdef IF_ETHER_NIC_NET_BUF_ALIGN
	uint8_t		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
#endif
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	uint8_t		halign[4 - IF_HDR_ALIGN];
#endif
	uint8_t		buf[128]; /* Хåե	*/
	} T_NET_BUF_128;

/*
 *  256 ƥå
 */

typedef struct t_net_buf_256 {
	uint16_t	len;	/* ǡĹ		*/
	uint8_t		idix;	/* mpfid Υǥå	*/
	uint8_t		flags;	/* ե饰		*/
#ifdef IF_ETHER_NIC_NET_BUF_ALIGN
	uint8_t		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
#endif
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	uint8_t		halign[4 - IF_HDR_ALIGN];
#endif
	uint8_t		buf[256]; /* Хåե	*/
	} T_NET_BUF_256;

/*
 *  512 ƥå
 */

typedef struct t_net_buf_512 {
	uint16_t	len;	/* ǡĹ		*/
	uint8_t		idix;	/* mpfid Υǥå	*/
	uint8_t		flags;	/* ե饰		*/
#ifdef IF_ETHER_NIC_NET_BUF_ALIGN
	uint8_t		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
#endif
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	uint8_t		halign[4 - IF_HDR_ALIGN];
#endif
	uint8_t		buf[512];/* Хåե	*/
	} T_NET_BUF_512;

/*
 *  1024 ƥå
 */

typedef struct t_net_buf_1024 {
	uint16_t	len;	/* ǡĹ		*/
	uint8_t		idix;	/* mpfid Υǥå	*/
	uint8_t		flags;	/* ե饰		*/
#ifdef IF_ETHER_NIC_NET_BUF_ALIGN
	uint8_t		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
#endif
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	uint8_t		halign[4 - IF_HDR_ALIGN];
#endif
	uint8_t		buf[1024]; /* Хåե	*/
	} T_NET_BUF_1024;

/*
 *  ͥåȥ󥿥եκ PDU 
 */

typedef struct t_net_buf_if_pdu {
	uint16_t	len;	/* ǡĹ		*/
	uint8_t		idix;	/* mpfid Υǥå	*/
	uint8_t		flags;	/* ե饰		*/
#ifdef IF_ETHER_NIC_NET_BUF_ALIGN
	uint8_t		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
#endif
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	uint8_t		halign[4 - IF_HDR_ALIGN];
#endif
	uint8_t		buf[IF_PDU_SIZE];
				/* Хåե		*/
#if defined(IF_PDU_HDR_PADDING)
	uint8_t		padding[IF_PDU_HDR_PADDING];
#endif				/* إå;ʬ		*/
	} T_NET_BUF_IF_PDU;

/*
 *  ͥåȥХåեɽ
 */

typedef struct t_net_buf_entry {

	uint16_t	index;
	uint_t		size;

#if NET_COUNT_ENABLE & PROTO_FLG_NET_BUF

	ulong_t		prepares;
	ulong_t		requests;
	ulong_t		allocs;
	ulong_t		errors;

#endif	/* of #if NET_COUNT_ENABLE & PROTO_FLG_NET_BUF */

	} T_NET_BUF_ENTRY;

/*
 *  ͥåȥХåեե饰	
 */

/*
 *  ͥåȥ󥿥եϸ˥ͥåȥХåեʤ
 *  : ϸˤΥե饰ϥꥢ롣
 */
#define NB_FLG_NOREL_IFOUT	UINT_C(0x80)

/*
 *  ESP ѥե饰
 */
#define NB_FLG_DECRYPED		UINT_C(0x40)

/*
 *  ͥåȥХåե°
 */

/* õ° */

#define NBA_SEARCH_ASCENT	UINT_C(0x1000)	/* 礭ʥõ롣	*/
#define NBA_SEARCH_DESCENT	UINT_C(0x2000)	/* ʥõ롣	*/
#define NBA_RESERVE_TCP		UINT_C(0x4000)	/* TCP Ѥ˥ͥåȥХåեͽ󤹤롣*/
#define NBA_ID_MASK		UINT_C(0x0fff)	/* ̿ü ID ϤΥޥ	*/

/*
 *  ؿߥ졼ޥ
 */

#define get_net_buf(b,l)	tget_net_buf((b),(l),TMO_FEVR)

/*
 *  ؿ
 */

extern ER tget_net_buf_ex (T_NET_BUF **blk, uint_t minlen, uint_t maxlen, ATR nbatr, TMO tmout);
extern ER tget_net_buf (T_NET_BUF **blk, uint_t len, TMO tmout);
extern ER rel_net_buf (T_NET_BUF *blk);
extern ER rus_net_buf (T_NET_BUF *blk);
extern ER_UINT net_buf_siz (T_NET_BUF *blk);
extern uint_t net_buf_max_siz (void);
extern const T_NET_BUF_ENTRY *nbuf_get_tbl (void);
extern uint_t nbuf_get_tbl_size (void);

#endif	/* of #ifndef _NET_BUF_H_ */
